unit Sample_u;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
	Forms, Dialogs, StdCtrls, SmTool, ExtCtrls;

type
	TSampMain = class(TForm)
    Memo1: TMemo;
    CmdLightOn: TButton;
    CmdLightOff: TButton;
    CmdPresCode: TButton;
    EdtCodeValue: TEdit;
    CmdReadFile: TButton;
    CmdCardOn: TButton;
    Label1: TLabel;
    Edit2: TEdit;
    CmdCardOff: TButton;
    CmdRead20: TButton;
    ListBox1: TListBox;
    ListBox2: TListBox;
    Label2: TLabel;
    Label3: TLabel;
    CmdWriteFile: TButton;
    EdtFileNum: TEdit;
    EdtFileData: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    CmdReaderStatus: TButton;
    CmdGetManID: TButton;
    EdtGempValues: TEdit;
    EdtCodeNum: TEdit;
    CmdCodeStatus: TButton;
    CmdLoadCode: TButton;
    CmdPresMaster: TButton;
    CmdCreateFile: TButton;
    CmdTimeOut: TButton;
    CmdDefineCard: TButton;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    EdtFileLength: TEdit;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    CmdChangeCode: TButton;
    CmdLoadMaster: TButton;
    Label9: TLabel;
    SmTool1: TSmTool;
{    procedure CateCommReceive(Sender: TObject; Count: Word);
    procedure CateCommTransmit(Sender: TObject; Count: Word);
 }
    procedure DisplayIt;

    procedure CmdGetManIDClick(Sender: TObject);
    procedure CmdLightOnClick(Sender: TObject);
    procedure CmdLightOffClick(Sender: TObject);
    procedure CmdPresCodeClick(Sender: TObject);
    procedure CmdReadFileClick(Sender: TObject);
    procedure CmdCardOnClick(Sender: TObject);
    procedure CmdCardOffClick(Sender: TObject);
    procedure CmdRead20Click(Sender: TObject);
    procedure CmdWriteFileClick(Sender: TObject);
    procedure CmdReaderStatusClick(Sender: TObject);
    procedure CmdCodeStatusClick(Sender: TObject);
    procedure CmdLoadCodeClick(Sender: TObject);
    procedure CmdPresMasterClick(Sender: TObject);
    procedure CmdCreateFileClick(Sender: TObject);
    procedure CmdTimeOutClick(Sender: TObject);
    procedure CmdDefineCardClick(Sender: TObject);
    procedure CmdChangeCodeClick(Sender: TObject);
    procedure CmdLoadMasterClick(Sender: TObject);
{    procedure SmTool1Receive(Sender: TObject; Count: Word);
  }
  private
		{ Private declarations }
    SendBuffer: string;
  public
    { Public declarations }

  end;

var
	SampMain: TSampMain;

implementation

{$R *.DFM}

(*
procedure TSampMain.CateCommReceive(Sender: TObject; Count: Word);
{this procedure is not needed}
var
	ReceivedData: string;   {array[0..255] of char;}
	Index: Integer;
begin
{        SmCdRdr1.read(ReceivedData,255);}
{receivedData := SmCdRdr1.RtnCode;
         showmessage(ReceivedData);
         showmessage('received event'); }
end;


procedure TSampMain.CateCommTransmit(Sender: TObject; Count: Word);
begin
	Memo1.Lines.Add ('Got a TRANSMIT event');
end;
  *)
procedure TSampMain.DisplayIt;
{Display the component properties rtncode and rtndata on form}
begin
     memo1.lines.add(smtool1.rtncode);
     edit2.text := smtool1.rtndata;
end;


procedure TSampMain.CmdGetManIDClick(Sender: TObject);
{Get manufacturing information - for ME2000}
begin
    SmTool1.ExecuteCommand(['CrdReadMan']);
    DisplayIt;
end;


procedure TSampMain.CmdLightOnClick(Sender: TObject);
{Turn on Litronic LED light}
begin
     try
        SmTool1.ExecuteCommand(['RdrLightOn']);
        DisplayIt;
     except
       On EGPFault do
          begin
               showmessage('GPF Error Trapped');
          end;
    end;  {try}
end;

procedure TSampMain.CmdLightOffClick(Sender: TObject);
{Turn off Litronic LED light}
begin
     SmTool1.ExecuteCommand(['RdrLightOff']);
     DisplayIt;
end;


procedure TSampMain.CmdPresCodeClick(Sender: TObject);
{Present secret code- EdtCodeValue as secret code number- EdtCodeNum}
begin
  try
     SmTool1.ExecuteCommand(['CrdPresentCode', EdtCodeNum.text, EdtCodeValue.text]);
     DisplayIt;
  except
        on EGPFault do
         showmessage('GPF Error in Sample');

     end;
 end;

procedure TSampMain.CmdReadFileClick(Sender: TObject);
begin
     {Attempt conventional read command}
     SmTool1.ExecuteCommand(['CrdReadFile', EdtFileNum.text, EdtFileLength.text]);    {File number and length}
     if SmTool1.RtnData = FLAG_NSF then
     begin
     {must be 2-step process (i.e. schlumberger card) where open file and then read}
         SmTool1.ExecuteCommand(['CrdOpenFile', EdtFileNum.text, 'FF']);
         If SmTool1.RtnData = 'ok' then
         begin
              SmTool1.ExecuteCommand(['CrdReadOpenFile', EdtFileLength.text]);
         end;
     end;
     DisplayIt;
end;


procedure TSampMain.CmdCardOnClick(Sender: TObject);
{Same as Card reset}
begin
     try
          SmTool1.ExecuteCommand(['RdrReset']);
          DisplayIt;
     except
       On EGPFault do
          begin
               showmessage('GPF error trapped');
          end;
     end;  {try}
end;


procedure TSampMain.CmdCardOffClick(Sender: TObject);
{Power Card off}
begin
     SmTool1.ExecuteCommand(['RdrCardOff']);
     displayIt;
end;


procedure TSampMain.CmdRead20Click(Sender: TObject);
var
   numfiles: integer;
   index: integer;
begin
{Works with Gemplus card using combination of select and read commands}

{Select all to get appropriate lengths}
     SmTool1.ExecuteCommand(['CrdSelectFirst']);
     DisplayIt;
     listbox1.items.add(copy(SmTool1.RtnData, 10, 2));
     numfiles := 1;
     Repeat
           SmTool1.ExecuteCommand(['CrdSelectNext']);
           listbox1.items.add(copy(SmTool1.RtnData, 10, 2));
           DisplayIt;
           numfiles := numfiles + 1
     until numfiles > 20;

{now read all values}
     for index := 1 to (numfiles-1) do
     Begin
          SmTool1.ExecuteCommand(['CrdReadFile', inttostr(index), Inttostr(SmTool1.HextoInt(listbox1.items[index]))]);
          DisplayIt;
          listbox2.items.add(SmTool1.RtnData);
     end
end;


procedure TSampMain.CmdWriteFileClick(Sender: TObject);
{write data to selected file}
var
   num: string;
   len: string;
   val: string;
begin
     num := EdtFileNum.text;
     val := EdtFileData.text;
     len := inttostr(length(val));
     {try standard write first}
     SmTool1.ExecuteCommand(['CrdWriteFile', num, len, val]);
     if SmTool1.RtnData = FLAG_NSF then
     {if fails than try 2-step write .... open file and then write new data}
     begin
        SmTool1.ExecuteCommand(['CrdOpenFile', num, 'FF']);
        if SmTool1.RtnData = 'ok' then
        begin
           SmTool1.ExecuteCommand(['CrdWriteOpenFile', len, val]);
        end
        else
        begin
           showmessage('File could not be opened');
        end;
     end;
     Displayit;
end;

procedure TSampMain.CmdReaderStatusClick(Sender: TObject);
{Get Reader status}
begin
     SmTool1.ExecuteCommand(['RdrStatus']);
     DisplayIt;
end;


procedure TSampMain.CmdCodeStatusClick(Sender: TObject);
{Get number of incorrcet presentations for selected secret code}
begin
      SmTool1.ExecuteCommand(['CrdCodeStatus', EdtCodeNum.text]);
      displayit;
end;


procedure TSampMain.CmdLoadCodeClick(Sender: TObject);
{Load new secret code}
begin
     SmTool1.ExecuteCommand(['CrdLoadCode', EdtCodeNum.text, EdtCodeValue.text]);
     DisplayIt;
end;


procedure TSampMain.CmdPresMasterClick(Sender: TObject);
{Present Master Key - ME2000 uses this convention}
begin
     SmTool1.ExecuteCommand(['CrdPresentMasterCode', EdtCodeValue.text]);
     DisplayIt;
end;


procedure TSampMain.CmdCreateFileClick(Sender: TObject);
{Create a file protected by secret code 1}
begin
     SmTool1.ExecuteCommand(['CrdCreateFile', EdtFileLength.text]);
     if SmTool1.RtnData = FLAG_NSF then
     begin
       SmTool1.ExecuteCommand(['CrdCreatePurseFile', EdtFileNum.text, EdtFileLength.text, '11']);
     end;
     displayit;
end;


procedure TSampMain.CmdTimeOutClick(Sender: TObject);
{Change timeout for battery operated Gemplus Reader}
begin
       SmTool1.ExecuteCommand(['RdrTimeOut', EdtGempValues.text]);
       displayit;

end;

procedure TSampMain.CmdDefineCardClick(Sender: TObject);
{Change Gemplus reader to different card mode}
begin
        SmTool1.ExecuteCommand(['RdrDefineCard', EdtGempValues.text]);
       displayit;

end;

procedure TSampMain.CmdChangeCodeClick(Sender: TObject);
begin
       SmTool1.ExecuteCommand(['CrdUpdateCode', EdtCodeNum.text, EdtCodeValue.text]);
       displayit;

end;

procedure TSampMain.CmdLoadMasterClick(Sender: TObject);
{Load master key}
begin
       SmTool1.ExecuteCommand(['CrdLoadMasterKey', EdtCodeValue.text]);
       displayit;
end;


initialization
end.
